package multiava.gfx;

import com.emarcotte.glfoo.ApplicationContext;
import com.emarcotte.glfoo.implementation.DefaultRenderingContext;
import com.emarcotte.glfoo.implementation.FocusableCamera;
import com.emarcotte.glfoo.implementation.GraphicRenderer;

public class GameRenderingContext extends DefaultRenderingContext {

	public GameRenderingContext(ApplicationContext c) {
		super();

		Man m = new Man();
		Ground g = new Ground();
		Sky s = new Sky(m.getPosition());
		ScoreArea score = new ScoreArea(m);
		RedShit r = new RedShit();

		c.getMainWindow().addKeyListener(m);
		FocusableCamera cam = new FocusableCamera();

		cam.setDistance(10);
		cam.setFocus(m.getPosition());
		GraphicRenderer gr = new GraphicRenderer(cam);
		addRenderer(gr);

		gr.addRenderable(s);
		gr.addRenderable(r);
		gr.addRenderable(g);
		gr.addRenderable(score);
		gr.addRenderable(m);
	}
}
