package multiava.gfx;

import java.io.IOException;

import javax.media.opengl.GL;
import javax.media.opengl.GLException;

import com.emarcotte.glfoo.GraphicsDriver;
import com.emarcotte.glfoo.Renderable;
import com.emarcotte.glfoo.utils.ResourceHandler;
import com.sun.opengl.util.texture.Texture;
import com.sun.opengl.util.texture.TextureIO;

public class Ground implements Renderable {
	TexturedQuad q;

	public Ground() {

	}

	@Override
	public void draw(GraphicsDriver driver) {
		GL gl = driver.getGl();
		gl.glPushMatrix();
		gl.glPushAttrib(GL.GL_CURRENT_BIT);
		gl.glColor3d(1, 0, 0);
		gl.glTranslated(0, -3, 0);
		gl.glScaled(12, 4, 0);
		q.draw(driver);
		gl.glPopAttrib();
		gl.glPopMatrix();
	}

	@Override
	public void init(GraphicsDriver driver) {
		Texture t = null;
		try {
			t = TextureIO.newTexture(ResourceHandler.getHandler()
					.getResourceAsStream("dirt12.jpg"), false, TextureIO.JPG);
		} catch (GLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		t.setTexParameteri(GL.GL_TEXTURE_WRAP_S, GL.GL_REPEAT);
		t.setTexParameteri(GL.GL_TEXTURE_WRAP_T, GL.GL_REPEAT);
		
		q = new TexturedQuad(t, 3);
		
		q.init(driver);

	}

}
