package multiava.gfx;

import java.awt.Color;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.IOException;

import javax.media.opengl.GL;
import javax.media.opengl.GLException;

import com.emarcotte.glfoo.GraphicsDriver;
import com.emarcotte.glfoo.Renderable;
import com.emarcotte.glfoo.math.Vector3;
import com.emarcotte.glfoo.utils.ResourceHandler;
import com.sun.opengl.util.texture.Texture;
import com.sun.opengl.util.texture.TextureIO;

public class Man implements Renderable, KeyListener {

	private Vector3 position;
	private TexturedQuad q;
	private double yVelocity;
	private double xVel;
;

	public Man() {
		position = new Vector3(0, 0, 0);
		
	}

	public Vector3 getPosition() {
		return position;
	}

	@Override
	public void draw(GraphicsDriver driver) {
		GL gl = driver.getGl();
		gl.glPushMatrix();
		gl.glTranslated(position.getI(), position.getJ(), position.getK());
		q.draw(driver);
		gl.glPopMatrix();
		position.addI(xVel);
		if (position.getJ() > 0 || yVelocity != 0) {
			yVelocity += .01;
			position.addJ(-yVelocity);
		}

		if (position.getJ() <= 0.0) {
			yVelocity = 0.0;
			position.setJ(0);
		}

	}

	@Override
	public void init(GraphicsDriver driver) {
		Texture t = null;
		try {
			t = TextureIO.newTexture(ResourceHandler.getHandler()
					.getResourceAsStream("Towelie.jpg"), false, TextureIO.JPG);
		} catch (GLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		q = new TexturedQuad(t, 180 / 256.0);
		q.init(driver);

	}

	@Override
	public void keyPressed(KeyEvent e) {

		if (e.getKeyCode() == KeyEvent.VK_UP) {
			yVelocity -= .15;
		}
		if (e.getKeyCode() == KeyEvent.VK_LEFT) {
			if (xVel == .1) {
				xVel = 0;
			} else {
				xVel = -.1;
			}
		}
		if (e.getKeyCode() == KeyEvent.VK_RIGHT) {
			if (xVel == -.1) {
				xVel = 0;
			} else {
				xVel = .1;
			}
		}
	}

	@Override
	public void keyReleased(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_LEFT && xVel < 0) {
			xVel = 0;
		}
		if (e.getKeyCode() == KeyEvent.VK_RIGHT && xVel > 0) {
			xVel = 0;
		}
	}

	@Override
	public void keyTyped(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_UP) {
			yVelocity -= .1;
		}

	}

}
