package multiava.gfx;

import javax.media.opengl.GL;

import com.emarcotte.glfoo.GraphicsDriver;
import com.emarcotte.glfoo.Renderable;
import com.emarcotte.glfoo.math.Vector3;

/**
 */
public class Sky implements Renderable {
	private Vector3 center;
	private float[] lower;
	private float[] upper;

	public Sky(Vector3 watch) {
		center = watch;
		lower = new float[] { 0, 0, 0 };
		upper = new float[] { 0, 0, 0 };
	}

	@Override
	public void draw(GraphicsDriver driver) {
		float height = (float) center.getJ();
		if (center.getJ() < 400) {
			lower[0] = 1 + height / 800;
			lower[1] = 1 - height / 800;
			lower[2] = 1 - height / 800;
			upper[0] = .13f + height / 400;
			upper[1] = .32f - height / 800;
			upper[2] = .36f - height / 800;
		} else {

		}

		GL gl = driver.getGl();
		gl.glPushMatrix();
		gl.glPushAttrib(GL.GL_CURRENT_BIT);
		gl.glTranslated(0, center.getJ(), 0);
		gl.glScaled(7, 5, 0);
		gl.glBegin(GL.GL_QUADS);

		gl.glColor3d(lower[0], lower[1], lower[2]);
		gl.glVertex3d(1, -1, 0);
		gl.glVertex3d(-1, -1, 0);

		gl.glColor3d(upper[0], upper[1], upper[2]);
		gl.glVertex3d(-1, 1, 0);
		gl.glVertex3d(1, 1, 0);
		gl.glEnd();
		gl.glPopAttrib();
		gl.glPopMatrix();

	}

	@Override
	public void init(GraphicsDriver driver) {
		// TODO Auto-generated method stub

	}

}
