package multiava.gfx;

import java.awt.Point;
import java.awt.event.MouseEvent;

import javax.swing.SwingUtilities;

import com.emarcotte.glfoo.MouseHandler;
import com.emarcotte.glfoo.implementation.FocusableCamera;

public class TestrioMouseHandler implements MouseHandler {
	private Point mousePoint;

	private FocusableCamera camera;

	public TestrioMouseHandler(FocusableCamera camera) {
		this.camera = camera;
		mousePoint = new Point();
	}

	@Override
	public void mouseDragged(MouseEvent e) {
		if (SwingUtilities.isRightMouseButton(e)) {
			double z = camera.getDistance();
			double diff = e.getY() - mousePoint.getY();
			if (diff != 0) {
				z -= z / diff * .010;
			}
			camera.setDistance(z);
		}

		if (SwingUtilities.isLeftMouseButton(e)) {
			double dX = e.getX() - mousePoint.getX();
			double dY = e.getY() - mousePoint.getY();
			camera.addYAngle(dY);
			camera.addXAngle(dX);
		}

		this.mousePoint = e.getPoint();

	}

	@Override
	public void mouseMoved(MouseEvent e) {
		this.mousePoint = e.getPoint();
	}

	@Override
	public void mouseClicked(MouseEvent e) {

	}

	@Override
	public void mouseEntered(MouseEvent e) {

	}

	@Override
	public void mouseExited(MouseEvent e) {

	}

	@Override
	public void mousePressed(MouseEvent e) {

	}

	@Override
	public void mouseReleased(MouseEvent e) {

	}

	@Override
	public Point getMousePoint() {
		return mousePoint;
	}
}
