package multiava.gfx;

import javax.media.opengl.GL;

import com.emarcotte.glfoo.GraphicsDriver;
import com.emarcotte.glfoo.Renderable;
import com.sun.opengl.util.texture.Texture;

public class TexturedQuad implements Renderable {
	private VertexBufferObject vertexBufferObject;
	private Texture t;

	public TexturedQuad(Texture t, double scale) {
		vertexBufferObject = new VertexBufferObject();
		vertexBufferObject.setVertexPositions(new double[] { -.5, -.5, 0, -.5,
				.5, 0, .5, .5, 0, .5, -.5, 0 }, GL.GL_QUADS);
		vertexBufferObject.setTextureCoordinates(new double[] { 0, scale, 0, 0,
				scale, 0, scale, scale });
		this.t = t;
	}

	public TexturedQuad(Texture t) {
		this(t, 1);
	}

	public VertexBufferObject getVBO() {
		return vertexBufferObject;
	}

	@Override
	public void draw(GraphicsDriver driver) {
		GL gl = driver.getGl();
		gl.glPushMatrix();
		gl.glPushAttrib(GL.GL_CURRENT_BIT);

		if (t != null) {
			gl.glColor3d(1, 1, 1);
			t.bind();
		}

		vertexBufferObject.draw(driver);

		if (t != null) {
			gl.glBindTexture(t.getTarget(), 0);
		}
		gl.glPopAttrib();
		gl.glPopMatrix();
	}

	@Override
	public void init(GraphicsDriver driver) {
		GL gl = driver.getGl();
		gl.glEnable(GL.GL_TEXTURE_2D);

		vertexBufferObject.init(driver);
	}
}
